package java.net;

public final class DatagramPacket {
   private byte[] buf;
   private int length;
   private InetAddress address;
   private int port;

   public DatagramPacket(byte[] ibuf, int ilength) {
      if (ilength > ibuf.length) {
         throw new IllegalArgumentException("illegal length");
      } else {
         this.buf = ibuf;
         this.length = ilength;
         this.address = null;
         this.port = -1;
      }
   }

   public DatagramPacket(byte[] ibuf, int ilength, InetAddress iaddr, int iport) {
      if (ilength > ibuf.length) {
         throw new IllegalArgumentException("illegal length");
      } else {
         this.buf = ibuf;
         this.length = ilength;
         this.address = iaddr;
         this.port = iport;
      }
   }

   public InetAddress getAddress() {
      return this.address;
   }

   public int getPort() {
      return this.port;
   }

   public byte[] getData() {
      return this.buf;
   }

   public int getLength() {
      return this.length;
   }
}
