package java.net;

import java.io.FileDescriptor;
import java.io.IOException;

public class DatagramSocket {
   private int localPort;
   // $FF: renamed from: fd java.io.FileDescriptor
   private FileDescriptor field_0;

   public DatagramSocket() throws SocketException {
      this.field_0 = new FileDescriptor();
      this.datagramSocketCreate();
      this.localPort = this.datagramSocketBind(0);
   }

   public DatagramSocket(int port) throws SocketException {
      SecurityManager security = System.getSecurityManager();
      if (security != null) {
         security.checkListen(port);
      }

      this.field_0 = new FileDescriptor();
      this.datagramSocketCreate();
      this.localPort = this.datagramSocketBind(port);
   }

   public void send(DatagramPacket p) throws IOException {
      SecurityManager security = System.getSecurityManager();
      if (security != null) {
         security.checkConnect(p.getAddress().getHostAddress(), p.getPort());
      }

      this.datagramSocketSend(p);
   }

   public synchronized void receive(DatagramPacket p) throws IOException {
      InetAddress peekAddress = new InetAddress();
      int peekPort = this.datagramSocketPeek(peekAddress);
      SecurityManager security = System.getSecurityManager();
      if (security != null) {
         security.checkConnect(peekAddress.getHostAddress(), peekPort);
      }

      this.datagramSocketReceive(p);
   }

   public int getLocalPort() {
      return this.localPort;
   }

   public synchronized void close() {
      this.datagramSocketClose();
   }

   protected synchronized void finalize() {
      this.datagramSocketClose();
   }

   private native void datagramSocketCreate();

   private native int datagramSocketBind(int var1);

   private native void datagramSocketSend(DatagramPacket var1);

   private native int datagramSocketPeek(InetAddress var1);

   private native void datagramSocketReceive(DatagramPacket var1);

   private native void datagramSocketClose();

   private native void multicastJoinLeave(InetAddress var1, boolean var2);

   static {
      SecurityManager.setScopePermission();
      System.loadLibrary("net");
   }
}
