package java.net;

import java.io.FileOutputStream;
import java.io.IOException;

class SocketOutputStream extends FileOutputStream {
   private SocketImpl impl;
   private byte[] temp = new byte[1];

   SocketOutputStream(SocketImpl impl) throws IOException {
      super(impl.getFileDescriptor());
      this.impl = impl;
   }

   private native void socketWrite(byte[] var1, int var2, int var3) throws IOException;

   public void write(int b) throws IOException {
      this.temp[0] = (byte)b;
      this.socketWrite(this.temp, 0, 1);
   }

   public void write(byte[] b) throws IOException {
      this.socketWrite(b, 0, b.length);
   }

   public void write(byte[] b, int off, int len) throws IOException {
      this.socketWrite(b, off, len);
   }

   public void close() throws IOException {
      this.impl.close();
   }

   protected void finalize() {
   }
}
